/*
 * Global.java
 *
 * Created on December 31, 2004, 3:32 PM
 */

import java.io.*;
import java.awt.*;
import java.util.*;

/**
 *  global data and methods
 * @author  dsmith
 */
public class Global {
    /** the host panel */
    public static MyPanel myPanel; 
    /** diagnostic print stream */
    public static PrintStream debug;
     /** diagnostic print stream */
    public static PrintStream out;
    /** buffered input stream */
    public static BufferedReader input = null;
    /** diagnostic print stream enabler */
    public static boolean doDbg = false;
    /** output print stream enabler */
    public static boolean doOut = false;
    /** standalone or jApplet? */
    public static boolean isStandalone = false;
    /** screen size */
    public static Dimension screenSize = new Dimension(800, 600);
    /** Time step for real-time execution */
    public static double DT;
    
    public static float size=100.0f; // ???????(??)
    public static int n=3; // u???????(n>0)
    public static int m=3; // v???????(m>0)
    public static int usubdivi=25; // u??????
    public static int vsubdivi=25; // u??????

/* ????????? */
    public static double theta=0.0; // radians
    public static double phi=0.0; // radians
    public static double d0=200.0f; // ????????????????
    public static double d=d0; // ????????????
    public static Vector eye; // ?????
    public static double mat[]; // ????
    public static int omegadeg=25; // ??(???)
    public static double omegarad=(float)omegadeg*Math.PI/180.0f; // ??(???)
    public static double radius=50.0f; // ????
    public static double f=radius/Math.tan(omegarad/2.0f); // ???

/* ??????????? */
    public static boolean ctrlPointSelectedFlag = false; // ???????????
    public static Index2D selectedCtrlPointIndex; // ???????????????
    public static Vector offset;
    public static double scale;
/* ????????? */
    public static boolean showCtrlPointsFlag = true; // ???
    public static boolean showBezierWiresFlag = true; // ?????
    public static boolean showBezierSurfacesFlag = true; // ?????
    public static boolean hiddenLineRemovalFlag = true; // ????
    public static int sourceShapeFlag = 0; // ???? (0)???(1)????(2)??
    public static boolean animationFlag = false; // ??????????(0)??(1)???(2)???(3)?+???

/* ???????????? */
    public static int counter=0;
    public static float timer=0.0f;
    public static float fps=0.0f;
    public static Color selectedColor = new Color(0, 255, 25);



    public static void init(boolean isStandalone) {
        DT = 0.03333;    // 30 times a second
        Global.isStandalone = isStandalone;
        if(isStandalone) {    
            try { 
                  debug = new PrintStream( new FileOutputStream( "debug.log" ) ); 
            } 
            catch( IOException e) { 
              System.out.print("Error " + e + " opening debug.log" ); 
            } 
            debug.println("debug log opened");
            doDbg = false;                  // >>>>> Set your initial debug state here <<<<<<<<<<
            try { 
                  out = new PrintStream( new FileOutputStream( "output.txt" ) ); 
            } 
            catch( IOException e) { 
              System.out.print("Error " + e + " opening output.txt" ); 
            } 
            out.println("output.txt opened");
            doOut = true;                  // >>>>> Set your initial output state here <<<<<<<<<<
        }
        mat = new double[9];
        offset = new Vector(400, 300);
        scale = 2.0;
        phi = -25.0 * Math.PI /  180; // radians
        theta = 0.0; // radians
    }

    

    
    public static void getEyeCoordinateAndTransformationMatrix() {
	double st = Math.sin(theta); 
	double ct = Math.cos(theta);
	double sp = Math.sin(phi); 
	double cp = Math.cos(phi);

        eye = new Vector(cp*ct*d, cp*st*d, -sp*d);
	// Global.debug.println( "eye: " + eye);

	mat[0]=ct*cp; mat[1]=st*cp; mat[2]=-sp;
	mat[3]=-st; mat[4]=ct; mat[5]=0.0f;
	mat[6]=ct*sp; mat[7]=st*sp; mat[8]=cp;
    }
    
    public static Vector processPerspectiveTransformation(Vector input) {

	Vector diff = new Vector(input.x-eye.x, input.y-eye.y, input.z-eye.z);

	Vector inte = new Vector(mat[0]*diff.x+mat[1]*diff.y+mat[2]*diff.z,
                                 mat[3]*diff.x+mat[4]*diff.y+mat[5]*diff.z,
                                 mat[6]*diff.x+mat[7]*diff.y+mat[8]*diff.z);
	//printf("inte: %f %f %f\n",inte.x,inte.y,inte.z);

	return new Vector( f*inte.y/inte.x, f*inte.z/inte.x);
    }


    public static Color processStandardizedValue2RGB(double x){

	Color c = null;
	float h = (1.0f - (float) x)*239.5f;
	h /= 40;
	int n = (int) h;
	float f = h - n;
	float p = 0; 
        float q = 1.0f - f; 
        float t = f;
	switch(n) {
		case 0:
			c = new Color( 1.0f, t, p);
			break;
		case 1:
			c = new Color( q, 1.0f, p);
			break;
		case 2:
			c = new Color( p, 1.0f, t);
			break;
		case 3:
			c = new Color( p, q, 1.0f);
			break;
		case 4:
			c = new Color( t, p, 1.0f);
			break;
		case 5:
			c = new Color( 1.0f, p, q);
			break;
	}
	return c;
    }

    
    
    public static void incrementalInversePerspectiveTransformation(Vector d, Vector base, Vector ctl) {

        double dp = d.x/f;
        double dq = d.y/f;
	Vector inte = new Vector(-mat[3]*dp - mat[6]*dq,
                                 -mat[4]*dp - mat[7]*dq,
                                 -mat[5]*dp - mat[8]*dq);
        ctl.copyValues(base.add(inte));
//	Global.debug.println("Selected changed to: " + ctrlPoint[selectedCtrlPointIndex.k][selectedCtrlPointIndex.l]);
    }


    public static void printMat(boolean trans) {
        String res = "mat";
        if(trans) res += "(-1)";
        res += ":\n";
        int ndx = 0;
        for(int i = 0; i < 3; i++) {
            for(int j = 0; j < 3; j++) {
                if(trans) ndx = j*3 + i;
                else ndx = i*3 + j;
                res += mat[ndx];
                if(j == 2) res += "\n";
                else res += ", ";
            }
        }
//        debug.println(res);
    }
}