/*
 * Patch.java
 *
 * Created on July 26, 2008, 4:58 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author dsmith
 */
import java.util.*;
import java.io.*;
import java.awt.*;

public class Patch {
    
    public Vector[][] ctrlPoint; // ???????????
    public Vector[][] bezierPoint; // ??????????????
    public ArrayList bezierSurface; // ??????????
    private int m, n;
    private int usubdivi, vsubdivi;
    private double size;
    
    /** Creates a new instance of Patch */
    public Patch(int sourceShapeFlag) {
        ctrlPoint = new Vector[Global.n+1][Global.n+1];
        bezierPoint = new Vector[Global.usubdivi][Global.vsubdivi];
        bezierSurface = new ArrayList<NormalVectorAndZvalue>();
        n = Global.n;
        m = Global.m;
        usubdivi = Global.usubdivi;
        vsubdivi = Global.vsubdivi;
        size = Global.size;
	float k,l; // [-0.5,+0.5]???

	// ???????????(???)
	for(int i = 0; i < n+1; i++) {
		for(int j = 0; j < m+1; j++) {
			k=(float)i/(float)n-0.5f;
			l=(float)j/(float)m-0.5f;
			ctrlPoint[i][j] = new Vector(size*k, size*l, 0);
                        ctrlPoint[i][j].setDimension(5);
			switch(sourceShapeFlag) {
                            case 0:
                                ctrlPoint[i][j].z=size*(k*k+l*l-0.25f)*2.0f; // ??? [-0.5*size,+0.5*size]                           
                                break;
                            case 1:
				ctrlPoint[i][j].z = size*(Math.sin(2*Math.PI*k)+Math.sin(2*Math.PI*l))/4; // ???? [-0.5*size,+0.5*size]
                                break;
                            case 2:
				ctrlPoint[i][j].z=0.0f; // ??
                                break;
                        }
//			Global.debug.println("ctrlPoint[" + i + "][" + j + "]: " + ctrlPoint[i][j]);
		}
	}
        getBezierPointsCoordinate();
        getBezierSurfacesNormalVector();
    }
    
    public void getBezierPointsCoordinate() {
	double u,v; // [0.0,1.0]???
	double bu[] = new double[n+2];
        double bv[] = new double[m+2];

	for(int k = 0; k < usubdivi; k++) {
		u=(double)k/(usubdivi-1);
		for(int i = 0; i < (n+2); i++) 
                    bu[i]=0;
		bu[1]=1.0;
		for(int i = 1; i < n+1; i++) {
			for(int j = i+1; j > 0; j--) {
				bu[j]=(1-u)*bu[j]+u*bu[j-1];
			}
		}
		for(int l = 0; l < vsubdivi; l++) {
			v=(double)l/(vsubdivi-1);
			for(int j = 0; j < (m+2); j++) 
                            bv[j]=0;
			// deCasteljau??????????v????????????????
			bv[1]=1;
			for(int j = 1; j < m+1; j++) {
				for(int i = j+1; i > 0; i--) {
					bv[i]=(1-v)*bv[i]+v*bv[i-1];
				}
			}
			// x, y, z???0.0????
			bezierPoint[k][l] = new Vector(0, 0, 0, 0, 0); 
			for(int i = 0; i < n+1; i++) {
				for(int j = 0; j < m+1; j++) {
					// x, y, z?????
					bezierPoint[k][l].x += ctrlPoint[i][j].x*bu[i+1]*bv[j+1];
					bezierPoint[k][l].y += ctrlPoint[i][j].y*bu[i+1]*bv[j+1];
					bezierPoint[k][l].z += ctrlPoint[i][j].z*bu[i+1]*bv[j+1];
				}
			}
		}
	}
    }

    public void getBezierSurfacesNormalVector() {
	int f = 0;
	for(int k = 0; k < usubdivi-1; k++){
		for(int l = 0; l < vsubdivi-1; l++) {
			Vector p1 = new Vector( bezierPoint[k+1][l] ); 
			Vector p2 = new Vector( bezierPoint[k][l] ); 
			Vector p3 = new Vector( bezierPoint[k][l+1] );
                        Vector nv = new Vector( (p2.y-p1.y)*(p3.z-p2.z)-(p2.z-p1.z)*(p3.y-p2.y),
                                                (p2.z-p1.z)*(p3.x-p2.x)-(p2.x-p1.x)*(p3.z-p2.z),
                                                (p2.x-p1.x)*(p3.y-p2.y)-(p2.y-p1.y)*(p3.x-p2.x));
			bezierSurface.add(new NormalVectorAndZvalue(k, l, nv));
		}
	}
    }

    public Index2D getTheNearestCtrlPointIndex(Vector input) {
	double threshold = 40; // ????????????????(???)(2.5f*2.5f)
	double mindist = threshold; // ???input?????????????(???)
	Index2D output = new Index2D(-1, -1); // ??????????????

	for(int i = 0; i < n+1; i++) {
		for(int j = 0; j < m+1; j++) {
			double diffx = input.x - ctrlPoint[i][j].p; 
			double diffy = input.y - ctrlPoint[i][j].q;
			double diff = diffx*diffx + diffy*diffy;
			if(diff <= mindist) {
				mindist=diff;
				output.k = i; 
				output.l = j;
			}
		}
	}
	return output;
    }
    
    public void getCtrlPointsTransformatedCoordinate() {
	for( int i = 0; i < n+1; i++) {
			for(int j = 0; j < m+1; j++) {
				Vector buffer = Global.processPerspectiveTransformation(ctrlPoint[i][j]);
				ctrlPoint[i][j].p = Global.scale * buffer.x + Global.offset.x; 
                                ctrlPoint[i][j].q = Global.scale * buffer.y + Global.offset.y;
			}
	}
    }

    public void getBezierPointsTransformatedCoordinate() {
	for(int k = 0; k < usubdivi; k++) {
			for(int l = 0; l < vsubdivi; l++) {
				Vector buffer = Global.processPerspectiveTransformation(bezierPoint[k][l]);
				bezierPoint[k][l].p = Global.scale * buffer.x + Global.offset.x; 
				bezierPoint[k][l].q = Global.scale * buffer.y + Global.offset.y;
			}
	}
    }

    public void getBezierSurfacesZvalue() {

	for(int f = 0; f < (usubdivi-1)*(vsubdivi-1); f++) {
                NormalVectorAndZvalue bsf = (NormalVectorAndZvalue) bezierSurface.get(f);
		int k = bsf.basicpoint.k; 
		int l = bsf.basicpoint.l;
		// ?(1)?(0)???
		if((Global.eye.x-bezierPoint[k][l].x)*bsf.n.x
		  +(Global.eye.y-bezierPoint[k][l].y)*bsf.n.y
		  +(Global.eye.z-bezierPoint[k][l].z)*bsf.n.z >= 0) {
			bsf.visible = true;
		}
		else {
			bsf.visible = false;
		}
		// ????????
		Vector gravityCenter = new Vector((bezierPoint[k][l].x+bezierPoint[k+1][l+1].x)/2,
                                                  (bezierPoint[k][l].y+bezierPoint[k+1][l+1].y)/2,
                                                  (bezierPoint[k][l].z+bezierPoint[k+1][l+1].z)/2);
		bsf.height = gravityCenter.z;
		// ???????????(???)???
		Vector diff = new Vector(Global.eye.x - gravityCenter.x,
                                         Global.eye.y - gravityCenter.y,
                                         Global.eye.z - gravityCenter.z);
		bsf.Z = diff.x*diff.x + diff.y*diff.y + diff.z*diff.z;
	}
    }

    public void processSortBezierSurfacesByZvalue() {
        Collections.sort(bezierSurface);
    }
    
    public void drawBezierSurfaces(Graphics g) {
	double standardizedheight; // [0.0,1.0]???
	Color surfacecolor;
	
	int[] x = new int[4];
        int[] y = new int[4];
	for(int f = 0; f < (usubdivi-1)*(vsubdivi-1); f++) {
                NormalVectorAndZvalue bsf = (NormalVectorAndZvalue) bezierSurface.get(f);
		int k = bsf.basicpoint.k; 
                int l = bsf.basicpoint.l;
		if(Global.showBezierSurfacesFlag || Global.hiddenLineRemovalFlag)	{
			if(Global.showBezierSurfacesFlag) {
				standardizedheight = (bsf.height + size*0.5)/size;
				if(standardizedheight < 0.0) standardizedheight = 0;
				else if(standardizedheight > 1.0) standardizedheight = 1;
				if(bsf.visible) {
					standardizedheight *= -1.0; 
                                        standardizedheight += 1.0;
				}
				surfacecolor = Global.processStandardizedValue2RGB(standardizedheight);
			}
			else surfacecolor = Color.BLACK;
                        x[0] = (int) bezierPoint[ k ][ l ].p; y[0] = (int) bezierPoint[ k ][ l ].q;
                        x[1] = (int) bezierPoint[k+1][ l ].p; y[1] = (int) bezierPoint[k+1][ l ].q;
                        x[2] = (int) bezierPoint[k+1][l+1].p; y[2] = (int) bezierPoint[k+1][l+1].q;
                        x[3] = (int) bezierPoint[ k ][l+1].p; y[3] = (int) bezierPoint[ k ][l+1].q;
                        g.setColor(surfacecolor);
                        g.fillPolygon(x, y, 4);
		}
		if(Global.showBezierWiresFlag)	{
			if(bsf.visible) g.setColor(Color.BLUE);
			else g.setColor(Color.RED);
                        g.drawPolygon(x, y, 4);
		}
	}
    }

    public void drawCtrlPoints(Graphics g) {
	if(Global.showCtrlPointsFlag) 	{
            g.setColor(Color.BLACK);
            // draw a dot at each control point
            int rad = (int)(2 * Global.scale);
            if(rad < 2) rad = 2;
            for(int i = 0; i < n+1; i++) {
                for(int j = 0; j < m+1; j++) {
                    g.fillOval( (int) ctrlPoint[i][j].p - rad, (int) ctrlPoint[i][j].q - rad, 2*rad, 2*rad);
		}
            }
            
            // draw lines between control points
             for(int i = 0; i < n+1; i++) {
                int px = (int) ctrlPoint[i][0].p;
                int py = (int) ctrlPoint[i][0].q;
		for(int j = 1; j < m+1; j++) {
                    g.drawLine(px, py, (int)ctrlPoint[i][j].p, (int) ctrlPoint[i][j].q);
                    px = (int) ctrlPoint[i][j].p;
                    py = (int) ctrlPoint[i][j].q;
		}
	    }
	    for(int j = 0; j < (m+1); j++)	{
                int px = (int) ctrlPoint[0][j].p;
                int py = (int) ctrlPoint[0][j].q;
                for(int i = 1; i < n+1; i++) {
                    g.drawLine(px, py, (int)ctrlPoint[i][j].p, (int) ctrlPoint[i][j].q);
                    px = (int) ctrlPoint[i][j].p;
                    py = (int) ctrlPoint[i][j].q;
                }
            }
            if(Global.ctrlPointSelectedFlag) {
		int i = Global.selectedCtrlPointIndex.k; 
                int j = Global.selectedCtrlPointIndex.l;
                g.setColor(Global.selectedColor);
                g.fillOval( (int) ctrlPoint[i][j].p - rad, (int) ctrlPoint[i][j].q - rad, 2*rad, 2*rad);
            }
	}
    }
    
    
    public static void main(String arg[]) {
        Global.init(true);
        // test the matrix transformations
        Global.theta = -Math.PI/4;
        Global.getEyeCoordinateAndTransformationMatrix();
        Global.printMat(false);
        Patch a = new Patch(0);
        Global.debug.println("first point is " + a.ctrlPoint[0][0]);
        Vector p = Global.processPerspectiveTransformation(a.ctrlPoint[0][0]);
        Global.debug.println("display coord is " + p);
        Global.selectedCtrlPointIndex = new Index2D(0, 0);
        Vector d = new Vector(1, -2);
        Vector base = new Vector(a.ctrlPoint[0][0]);
        Vector param = new Vector(d);
        param.scale(Global.f);
        Vector it = a.ctrlPoint[Global.selectedCtrlPointIndex.k][Global.selectedCtrlPointIndex.l];
        Global.incrementalInversePerspectiveTransformation(param, base, it);
        Global.debug.println("first point is now " + a.ctrlPoint[0][0]);
        Vector p1 = Global.processPerspectiveTransformation(a.ctrlPoint[0][0]);
        Global.debug.println("new display coord is " + p1 + "; should have added " + d + " to " + p);
    }
}
